<!DOCTYPE html>
<html>

<head>

    <title>VectorGrid.Protobuf example</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

</head>

<body style='margin:0'>

    <div id="map" style="width: 100vw; height: 100vh; background: white"></div>
    <div id="menu"></div>

    <script src='https://unpkg.com/maplibre-gl@latest/dist/maplibre-gl.js'></script>
    <link href='https://unpkg.com/maplibre-gl@latest/dist/maplibre-gl.css' rel='stylesheet' />
    <style>
        #menu {
            background: #fff;
            position: absolute;
            z-index: 1;
            top: 10px;
            right: 10px;
            border-radius: 3px;
            width: 120px;
            border: 1px solid rgba(0, 0, 0, 0.4);
            font-family: 'Open Sans', sans-serif;
        }

        #menu a {
            font-size: 13px;
            color: #404040;
            display: block;
            margin: 0;
            padding: 0;
            padding: 10px;
            text-decoration: none;
            border-bottom: 1px solid rgba(0, 0, 0, 0.25);
            text-align: center;
        }

        #menu a:last-child {
            border: none;
        }

        #menu a:hover {
            background-color: #f8f8f8;
            color: #404040;
        }

        #menu a.active {
            background-color: #3887be;
            color: #ffffff;
        }

        #menu a.active:hover {
            background: #3074a4;
        }
    </style>
    <!-- <script type="text/javascript" src="../dist/Leaflet.VectorGrid.bundled.js"></script> -->
    <script>
        const maxzoom = 10
        const style = {
            "version": 8,
            "sources": {
                "osm": {
                    "type": "raster",
                    "tiles": ["https://a.tile.openstreetmap.org/{z}/{x}/{y}.png"],
                    "tileSize": 256,
                    "attribution": "&copy; OpenStreetMap Contributors",
                    "maxzoom": 19
                }
            },
            "layers": [
                {
                    "id": "osm",
                    "type": "raster",
                    "source": "osm" // This must match the source key above
                }
            ],
            "glyphs": "http://fonts.openmaptiles.org/{fontstack}/{range}.pbf"
        };
        //console.log(geobuf.decode(new Pbf(")))
        var map = new maplibregl.Map({
            container: 'map',
            style: style, // stylesheet location
            center: [2.3477781534338646, 48.85696751585775], // starting position [lng, lat]
            zoom: 9, // starting zoom
            scaleControl: "bottom-left"
        });
        let scale = new maplibregl.ScaleControl({
            maxWidth: 80,
            unit: 'metric'
        });
        map.addControl(scale);
        map.addControl(new maplibregl.NavigationControl());

        map.on('load', () => {
            
            map.addSource('points', {
                type: 'vector',
                url: 'http://localhost:3000/cluster'
            })
            map.addSource('pond_per_cell', {
                type: 'vector',
                url: 'http://localhost:3000/pond_per_cell'
            })
            map.addSource('departments', {
            type: 'vector',
            url: 'http://localhost:3000/all_deps',
            })
            map.addLayer({
                id: 'm5',
                type: 'fill',
                source: 'pond_per_cell',
                'source-layer': 'pond_per_cell',
                paint: {
                    "fill-outline-color": "#000000",
                    "fill-color": {
                        property: "nb_mare",
                        stops: [
                            [1, "#e6f5d0"],
                            [2, "#a1d76a"],
                            [5, "#4d9221"],
                            [10, "#fde0ef"]
                        ],
                    },
                    "fill-opacity": 0.9,
                }})
            map.addLayer({
                id: 'departments',
                type: 'line',
                source: 'departments',
                'source-layer': 'all_deps'
            })
            const deps = ["Paris", "Seine-et-Marne", "Yvelines",
            "Essonne", "Hauts-de-Seine", "Seine-Saint-Denis", "Val-de-Marne"]
            deps.forEach(element => {
                const layerName = element.replaceAll('-','')
                map.addLayer({
                    id: layerName,
                    type: 'circle',
                    source: 'points',
                    'source-layer': layerName,
                    filter: ['has', 'point_count'],
                    paint: {
                        'circle-color': [
                            'step',
                            ['get', 'point_count'],
                            '#51bbd6',
                            100,
                            '#f1f075',
                            750,
                            '#f28cb1'
                        ],
                        'circle-radius': [
                            'step',
                            ['get', 'point_count'],
                            20,
                            100,
                            30,
                            750,
                            31
                        ]
                    }
                });
                map.addLayer({
                    id: `${layerName}-count`,
                    type: 'symbol',
                    source: 'points',
                    filter: ['has', 'point_count'],
                    'source-layer': layerName,
                    layout: {
                        'text-field': ['get', 'point_count'],
                        'text-size': 12,
                        'text-font': ['Open Sans Bold'],
                    },
                })
            
                map.addLayer({
                    id: `${layerName}-unclustered`,
                    type: 'circle',
                    source: 'points',
                    'source-layer': layerName,
                    filter: ['!', ['has', 'point_count']],
                });
            
                map.on('click', `${layerName}-unclustered`, (e) => {
                    console.log(e.features)
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    const description = e.features[0].properties.id_synthese;

                    // Ensure that if the map is zoomed out such that multiple
                    // copies of the feature are visible, the popup appears
                    // over the copy being pointed to.
                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }

                    new maplibregl.Popup()
                        .setLngLat(coordinates)
                        .setHTML(description)
                        .addTo(map);
                });
            })
        })
    </script>
</body>

</html>